package com.example.tracktrek;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.StreamCorruptedException;

import android.widget.AdapterView.OnItemClickListener;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.view.ViewGroup.LayoutParams;

/*
 * Previous Routes is a method to display all of the routes that have
 * been created using the Start Route button. Upon selecting a route,
 * the user can access the ElevationGraph or GoogleMaps View.
 */

public class PreviousRoutes extends Activity {
	public int i = 0;
	public final static String Selected_File = "com.example.tracktrek.SelectedFile";

	ListView listSavedFiles;
	String[] SavedFiles;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		setContentView(R.layout.activity_previous_routes);
		// getActionBar().setDisplayHomeAsUpEnabled(true);
	}

	public void buttonClick(View view) {


		FileInputStream fis;
		try {
			fis = openFileInput("marko.tmp");
			ObjectInputStream ois = new ObjectInputStream(fis);
			Object Route[] = (Object[]) ois.readObject();
			// ----------------------------------------------------------
			/*
			 * Important: Android crashes if I cast an Object Array to a
			 * locationDataArray
			 * 
			 * So I am not allowed to perform this step below - I do not know
			 * why locationData route[] = (locationData[]) Route;
			 */
			ois.close();
			i++;
			listSavedFiles = (ListView) findViewById(R.id.label_list);
			ShowSavedFiles();
			listSavedFiles.setOnItemClickListener(listSavedFilesOnItemClickListener);

		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (StreamCorruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	void ShowSavedFiles() {
		SavedFiles = getApplicationContext().fileList();
		ArrayAdapter<String> adapter = new ArrayAdapter<String>(this,
				android.R.layout.simple_list_item_1, SavedFiles);

		listSavedFiles.setAdapter(adapter);
	}

	// ---------------------------------------------------------------------------------

	OnItemClickListener listSavedFilesOnItemClickListener = new OnItemClickListener() {

		@Override
		public void onItemClick(AdapterView<?> parent, View view, int position,
				long id) {
			// Do something in response to the click
			// TODO Auto-generated method stub
			String clickedFile = (String) parent.getItemAtPosition(position);
			OpenFileDialog(clickedFile);
		}

	};

	void OpenFileDialog(final String file) {
		// Create a custom Dialog
		AlertDialog.Builder fileDialog = new AlertDialog.Builder(
				PreviousRoutes.this);
		fileDialog.setTitle(file);

		TextView textContent = new TextView(PreviousRoutes.this);
		textContent.setText(file);
		LayoutParams textViewLayoutParams = new LayoutParams(
				LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
		textContent.setLayoutParams(textViewLayoutParams);

		fileDialog.setView(textContent);

		fileDialog.setPositiveButton("Maps", new DialogInterface.OnClickListener() {
    		public void onClick(DialogInterface dialog, int whichButton) {
    		
    		  //I am doing something with the value
    			Toast.makeText(getApplicationContext(), "You chose maps, also Im batman",
    					Toast.LENGTH_LONG).show();
    			Intent OpenMapTrial = new Intent(PreviousRoutes.this,MapTrial.class);
    			OpenMapTrial.putExtra(Selected_File, file);
    	    	startActivity(OpenMapTrial);
    		  }
    		});

		fileDialog.setNegativeButton("ElevationGraph", new DialogInterface.OnClickListener() {
    		public void onClick(DialogInterface dialog, int whichButton) {
    		  //I am doing something with the value
    			Toast.makeText(getApplicationContext(), "You chose elevation, also Im batman",
    					Toast.LENGTH_LONG).show();
    			// This is where you should put your elevationgraph class
    			Intent OpenElevationGraph = new Intent(PreviousRoutes.this,ElevationGraph.class);
    			OpenElevationGraph.putExtra(Selected_File, file);
    	    	startActivity(OpenElevationGraph);
    		  }
    		});

		fileDialog.show();
	}
}
